=== debian/changelog ===
node-yarnpkg (4.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 4.1.0+dfsg
    All components being kept at the same version,
    except for zlib-ng 2.2.4. Closes: #1084310.
  * Drop memory-init-file option in yoga*
  * Fix compilation flag for libzip

  [ Yadd ]
  * Add hardening

 -- Jérémy Lal <kapouer@melix.org>  Thu, 10 Apr 2025 13:33:10 +0200

node-yarnpkg (4.0.2+dfsg-3) unstable; urgency=medium

  * Team upload

  [ Yadd ]
  * Try to render build reproducible
  * Fix @yarnpkg/builder/lib/cli.js permission
  * Unfuzz patches
  * Fix debian/watch

  [ Zixing Liu ]
  * Fix error "unsupported size of off_t" (Closes: #1067283)

 -- Yadd <yadd@debian.org>  Sun, 01 Sep 2024 12:19:48 +0400
