=== debian/watch ===
# yoga: should be manually downloaded at commit c09405d58c624fd26d5e0a7ed98bd10c5cc4c05b
# arcanis-libzip: should be manually downloaded at commit 664462465d2730d51f04437c90ed7ebcbe19a36f
# tinylogic: the downloaded tarball follows this naming pattern node-yarnpkg-tinylogic-git%Y%m%d.tar.xz

version=4
opts="mode=git,pgpmode=none,repack,repacksuffix=+dfsg,dversionmangle=auto" \
 https://github.com/yarnpkg/berry.git refs/tags/@yarnpkg/cli/@ANY_VERSION@

opts=\
component=dotenv,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-dotenv-$1/ \
 https://github.com/motdotla/dotenv/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts="mode=git,pgpmode=none,component=tinylogic,ctype=nodejs,dversionmangle=auto,pretty=tinylogic-git%cd" \
 https://github.com/arcanis/tinylogic.git HEAD ignore

opts=\
component=tau-prolog,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-tau-prolog-$1/ \
 https://github.com/tau-prolog/tau-prolog/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=readline-sync,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-readline-sync-$1/ \
 https://github.com/anseki/readline-sync/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=parse-url,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-parse-url-$1/ \
 https://github.com/IonicaBizau/parse-url/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=algoliasearch-client-javascript,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-algoliasearch-client-javascript-$1/ \
 https://github.com/algolia/algoliasearch-client-javascript/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=rollup-plugin-node-globals,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-rollup-plugin-node-globals-$1/ \
 https://github.com/calvinmetcalf/rollup-plugin-node-globals/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=ink,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-ink-$1/ \
 https://github.com/vadimdemedes/ink/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=ink-text-input,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-ink-text-input-$1/ \
 https://github.com/vadimdemedes/ink-text-input/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=patch-console,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-patch-console-$1/ \
 https://github.com/vadimdemedes/patch-console/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=yoga-wasm-web,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-yoga-wasm-web-$1/ \
 https://github.com/shuding/yoga-wasm-web/tags .*/archive.*/v?([\d\.]+).tar.gz ignore
